;; -*- geiser-scheme-implementation: guile -*-

(define (A x y)
    (cond ((= y 0) 0)
          ((= x 0) (* 2 y))
          ((= y 1) 2)
          (else (A (- x 1)
                   (A x (- y 1))))))

;; (A 1 1) == 2
;; (A 1 2) == (A 1 (A 1 1)) == (A 1 2) == 2 ^ 2 == 4
;; (A 2 3) == (A 1 (A 2 2)) == (A 1 (A 1 (A 1 1))) == (A 1 4) == 2 ^ 4 == 16
;; (A 2 4) == (A 1 (A 2 2)) == (A 1 (A 1 (A 1 1))) ==
;; (A 1 (A 1 (A 1 (A 1 1)))) == (A 1 (A 1 4)) == (A 1 (A 0 (A 1 3))) ==
;;     == (A 1 (A 0 (A 0 (A 1 2)))) ==
;;     == (A 1 (A 0 (A 0 (A 0 (A 1 1))))) ==
;;     == (A 1 16) == 2 ^ 16 == 65536

(A 1 10)
(A 2 4)
(A 3 3)

(define (f n) (A 0 n))   ;; == 2 * n
(define (g n) (A 1 n))   ;; == 2 ^ n
(define (h n) (A 2 n))   ;; == 2 ^ 2 ^ ... ^ 2 ^ 2, n > 0
(define (k n) (* 5 n n)) ;; == 5 * n ^ 2
